# do not forget to set priority to low compatible value (200)
# when the movement to JPackage will be finished!
%define priority 20000

Name: java-common
Version: 1.3.6
Release: alt2

Summary: Common files for Java runtimes
Group: System/Base
License: GPL
Packager: Igor Vlasenko <viy@altlinux.org>

Provides: %_bindir/java

Source0: java.sh
Source1: java-functions

Requires(post,preun): alternatives >= 0.2.0

BuildArch: noarch

BuildPreReq: rpm-build-java

%description
This package contains the Java wrapper that selects a Java runtime
environment available in the system to execute Java applications,
as well as common routines to set up Java application launcher
scripts.
The package also provides the system-wide installation directory
for Java packages.

%install

%__install -d -m 755 %buildroot%_datadir/%name
%__install -p -m 644 %SOURCE1 %buildroot%_datadir/%name/java-functions
%__subst -p 's,@LIBDIR@,%_prefix/lib,g; s,@LIB64DIR@,%_prefix/lib64,g; s,@JAVADIR@,%_javadir,g' \
    %buildroot%_datadir/%name/java-functions
# Provide symlink in %_libdir for backwards compatibility
%__mkdir_p %buildroot%_libdir
%__ln_s -nf $(relative %_datadir/%name %_libdir/) %buildroot%_libdir/java-common
%__install -d -m 755 %buildroot%_javadir
%__install -d -m 755 %buildroot%_javadocdir

# Install /usr/bin/java wrapper
%__install -p -m 755 %SOURCE0 %buildroot%_datadir/%name/java.sh
%__subst -p 's,@SCRIPTDIR@,%_datadir/%name,g' %buildroot%_datadir/%name/java.sh

# hack around smooth upgrade from 1.3.1
%__mkdir_p %buildroot%_bindir
ln -s $(relative %_datadir/%name/java.sh %_bindir/) \
    %buildroot%_bindir/java

# J2SE alternative
%__mkdir_p %buildroot%_altdir
%__cat <<EOF >%buildroot%_altdir/%name
%_bindir/java	%_datadir/%name/java.sh	%priority
EOF

# note: they are not needed in jpackage environment
# Install profile scripts
%__mkdir_p %buildroot%{_sysconfdir}/profile.d/
cat >%buildroot%{_sysconfdir}/profile.d/javahome.sh <<EOF
if test -e %{_prefix}/lib/jvm/java; then
    JAVA_HOME=%{_prefix}/lib/jvm/java
    export JAVA_HOME
    # dirty hack around libX11 w/xcb 
    LIBXCB_ALLOW_SLOPPY_LOCK=1
    export LIBXCB_ALLOW_SLOPPY_LOCK
else if test -e %{_prefix}/lib/jvm/java; then
    JRE_HOME=%{_prefix}/lib/jvm/jre
    export JRE_HOME
    # dirty hack around libX11 w/xcb 
    LIBXCB_ALLOW_SLOPPY_LOCK=1
    export LIBXCB_ALLOW_SLOPPY_LOCK
    fi
fi
EOF
chmod 755 %buildroot%{_sysconfdir}/profile.d/javahome.sh
cat >%buildroot%{_sysconfdir}/profile.d/javahome.csh <<EOF
if ( -e %{_prefix}/lib/jvm/java ) then
setenv JAVA_HOME %{_prefix}/lib/jvm/java
setenv LIBXCB_ALLOW_SLOPPY_LOCK 1
else if ( -e %{_prefix}/lib/jvm/jre ) then
setenv JRE_HOME %{_prefix}/lib/jvm/jre
setenv LIBXCB_ALLOW_SLOPPY_LOCK 1
endif
EOF
chmod 755 %buildroot%{_sysconfdir}/profile.d/javahome.csh

%post
%register_alternatives %name

%preun
%unregister_alternatives %name

%pre
%__rm -rf %_libdir/java-common

%triggerun -- java-common < 1.3
if [ -L %_libdir/java-common ]; then
    %__rm -f %_libdir/java-common
fi

%triggerpostun -- java-common < 1.3
%__ln_s -nf %_datadir/%name %_libdir/java-common

%files
%{_sysconfdir}/profile.d/javahome.*sh
%_altdir/%name
# hack around upgrade from 1.3.1 (%_bindir/java from file to symlink)
%_bindir/java
%_datadir/%name
%_libdir/java-common
%dir %_javadir
%dir %_javadocdir

%changelog
* Tue Sep 25 2007 Igor Vlasenko <viy@altlinux.ru> 1.3.6-alt2
- fixed syntax error

* Mon Sep 24 2007 Igor Vlasenko <viy@altlinux.ru> 1.3.6-alt1
- added JRE_HOME if JDK is not found
- added JVM search in jre

* Fri May 11 2007 Igor Vlasenko <viy@altlinux.ru> 1.3.5-alt1
- added LIBXCB_ALLOW_SLOPPY_LOCK=1 to hack around new libX11 w/xcb

* Mon Feb 19 2007 Igor Vlasenko <viy@altlinux.ru> 1.3.4-alt1
- fixed triggerpostun -- java-common < 1.3 
  ('relative' is for build environment only)

* Sun Feb 18 2007 Igor Vlasenko <viy@altlinux.ru> 1.3.3-alt1
- new profile scripts for JAVA_HOME (see #9766)
- %_bindir/java is moved to %_datadir/%name/java.sh
- symlink %_bindir/java is provided using alternatives
- raw symlink %_bindir/java is provided to fix upgrade

* Fri Feb 16 2007 Igor Vlasenko <viy@altlinux.ru> 1.3.2-alt1
- added basic JPackage support 
  (imtermediate version to allow smooth migration)

* Sun Oct 23 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.3.1-alt1
- Support 64-bit architectures by searching in /usr/lib64 as well (bug #8315)

* Sat Jun 25 2005 Mikhail Zabaluev <mhz@altlinux.ru> 1.3-alt1
- Incorporated jdkgcj fallback into the FindJVM function
  which also sets JAVA_BIN global variable
- Moved java-functions under /usr/share to be truly arch-independent

* Mon Dec 20 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.2-alt1
- Added FindJVM function to java-functions

* Sun Mar 07 2004 Mikhail Zabaluev <mhz@altlinux.ru> 1.1-alt1
- Provided fallback to jdkgcj in case no full-scale JDK is found
- Added a feature to the AddToClasspath function: non-absolute path names
  get prefixed with /usr/share/java

* Sat Oct 18 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.0-alt3
- Added the /usr/share/javadoc directory

* Mon Oct 06 2003 Mikhail Zabaluev <mhz@altlinux.ru> 1.0-alt2
- Added /usr/bin/java to Provides:

* Mon Nov 18 2002 Mikhail Zabaluev <mhz@altlinux.ru> 1.0-alt1
- Initial release

